$       SET NOVERIFY
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     SUSPEND.COM                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     SUSPEND ALL NON-SYSTEM PROCESSES PRIOR TO SYSTEM MAINTENANCE   !
$ !--------------------------------------------------------------------!
$ !     THIS PROCEDURE FILE SUSPENDS ALL ACTIVE NON-SYSTEM PROCESSES   !
$ !     WITHIN THE OPERATING SYSTEM PRIOR TO A SHUTDOWN OR OTHER       !
$ !     MAINTENANCE FUNCTION.  THE HEART OF THIS CAPABILITY IS IN THE  !
$ !     'SUSPEND' AND 'RESUME' UTILITIES WHICH RESPECTIVELY SUSPEND    !
$ !     AND RESUME A GIVEN PROCESS BY PROCESS NAME OR HEX PROCESS ID.  !
$ !--------------------------------------------------------------------!
$       ON CONTROL_Y THEN GOTO ABORT
$       ON ERROR THEN GOTO ABORT
$       ON WARNING THEN GOTO ABORT
$       SET NOON
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  SYSTEM SUSPENSION UTILITY  ***"
$ !--------------------------------------------------------------------!
$ !     DELETE FILES FROM LAST SYSTEM SUSPENSION                       !
$ !--------------------------------------------------------------------!
$       OPEN DELFIL PROCESS.DAT /READ /ERROR=SUSDAT
$       CLOSE DELFIL
$       DELETE PROCESS.DAT;*
$ !
$ SUSDAT:
$       OPEN DELFIL SUSPEND.DAT /READ /ERROR=PRCDAT
$       CLOSE DELFIL
$       DELETE SUSPEND.DAT;*
$ !--------------------------------------------------------------------!
$ !     GET SNAPSHOT OF CURRENT SYSTEM PROCESSES                       !
$ !--------------------------------------------------------------------!
$ PRCDAT:
$       ASSIGN /USER_MODE PROCESS.DAT SYS$OUTPUT
$       SHOW SYSTEM
$ !--------------------------------------------------------------------!
$ !     SEARCH SYSTEM PROCESSES AND SUSPEND USER PROCESSES             !
$ !--------------------------------------------------------------------!
$       OPEN PROCESS PROCESS.DAT /READ
$       READ PROCESS PRCDAT /END=NOMOREPROC
$       READ PROCESS PRCNAM /END=NOMOREPROC
$ !
$ GETPROCESS:
$       READ PROCESS PRCDAT /END=NOMOREPROC
$       PRCPID:='F$EXTRACT(1,10,PRCDAT)'
$       PRCNAM:='F$EXTRACT(11,15,PRCDAT)'
$       PRCGRP:='F$EXTRACT(26,3,PRCDAT)'
$       PRCSTA:='F$EXTRACT(34,3,PRCDAT)'
$ !--------------------------------------------------------------------!
$ !     DO NOT SUSPEND SYSTEM PROCESSES                                !
$ !--------------------------------------------------------------------!
$       IF (PRCSTA .EQS. "CUR") THEN GOTO GETPROCESS
$       ACP='F$LOCATE("ACP",PRCNAM)'
$       IF ((ACP .NE. 'F$LENGTH(PRCNAM)') .AND. (PRCGRP .EQS. "001")) -
             THEN GOTO GETPROCESS
$       IF (PRCNAM .EQS. "NULL") THEN GOTO GETPROCESS
$       IF (PRCNAM .EQS. "SWAPPER") THEN GOTO GETPROCESS
$       IF (PRCNAM .EQS. "JOB_CONTROL") THEN GOTO GETPROCESS
$       IF (PRCNAM .EQS. "OPCOM") THEN GOTO GETPROCESS
$       IF (PRCNAM .EQS. "ERRFMT") THEN GOTO GETPROCESS
$ !--------------------------------------------------------------------!
$ !     SUSPEND THE USER PROCESS                                       !
$ !--------------------------------------------------------------------!
$       ASSIGN /USER_MODE SUSPEND.DAT SYS$OUTPUT
$       SUSPEND 'PRCPID'
$       GOTO GETPROCESS
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     NO MORE PROCESS TO SUSPEND - RETURN CONTROL TO USER            !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ NOMOREPROC:
$       WRITE SYS$OUTPUT " "
$       TYPE SUSPEND.DAT
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  SYSTEM SUSPENSION COMPLETE  ***"
$       CLOSE PROCESS
$       DELETE PROCESS.DAT;*
$       EXIT
$ !--------------------------------------------------------------------!
$ !     ERROR EXIT                                                     !
$ !--------------------------------------------------------------------!
$ ABORT:
$       CLOSE PROCESS
$       DELETE PROCESS.DAT;*
$       DELETE SUSPEND.DAT;*
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  PROCEDURE ABORTED BY OPERATOR  ***"
$ !--------------------------------------------------------------------!
$ !     END OF PROCEDURE SUSPEND.COM                                   !
$ !--------------------------------------------------------------------!
