c
c
c	This is a program to emulate a terminal allowing a user
c	to dial up another computer and either pass or recieve 
c	ascii files.  The character variable term should be assigned
c	to the terminal port where the user has a data phone to
c	dial out on.  The <ctrl/a> key puts the program into command
c	mode where he can enter the following commands:
c
c	send <filename>     file to send default is send.dat
c	recv <filename>     file to recieve data default is recv.dat
c	close               close out the recieve file
c       stop                exit terminal emulator
c
c	The terminal should be in full duplex mode
c
c	written by R. E. Burroughs            OCT 15 1981
c
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	character tt*2/'TT'/,term*6/'TT$LUN'/,command_line*80
	character*4 send/'SEND'/,recv/'RECV'/,clo/'CLOS'/,sto/'STOP'/
	character*(60) filename
	dimension termchr(10),termdsc(2)
	byte ttbuf(80),termbuf(80),buffer(132),p4b(4)
	logical rcv,error,local,echo

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,olen

	external io$_ttyreadall,io$m_refresh,tt$m_noecho
	external io$_writevblk,io$_readvblk,io$_setmode
	equivalence (p4b(1),p4)
c
	termdsc(1)=40
	termdsc(2)=%loc(termchr(1))

c
c	put up a greeting to let him know the program is running
c
c

	type 1
1	format(///,'                    Terminal Emulation Routine '/
	1         ,'                            Version 1.2',//)


	rcv = .false.			!not in receive mode
c
c
c	now let's assign logical unit numbers to his terminal and the
c	one the modem is on
c

	status=sys$assign(tt,ttlun,,)		! his terminal
	if(.not. status) call lib$stop(%val(status))
	status=sys$assign(term,termlun,,)	! the one for the modem
	if(.not. status) call lib$stop(%val(status))

	status=sys$getchn(%val(ttlun),blen,termdsc,,)!find out if his terminal
	if(.not. status) call lib$stop(%val(status))!is in local or remote echo

	tnoecho = %loc(tt$m_noecho)
	l = iand(tnoecho,termchr(3))
	if( l .eq. 0 )then
		echo = .true.
	else
		echo = .false.
	end if

c
c	clear all of the event flags we are going to use
c

	status=sys$clref(%val(5))
	if(.not. status) call lib$stop(%val(status))
	status=sys$clref(%val(6))
	if(.not. status) call lib$stop(%val(status))
	status=sys$clref(%val(7))
	if(.not. status) call lib$stop(%val(status))


c
c	set up read function to pass all and refresh
c

	funcr=%loc(io$_ttyreadall).or.%loc(io$m_refresh)

c
c	now issue an async read to his terminal and the one
c	for the modem.  AST's will take care of the read.

	Call Localast

	Call Remoteast

c
c	set up mask for flag  7 and wait for it
c

100	mask = '200'O

	status=sys$wflor(%val(1),%val(mask))
	if(.not. status) call lib$stop(%val(status))
c
c	Got one. Read all of the flags in cluster 1
c

	status=sys$readef(%val(1),%ref(event_flags))
	if(.not. status) call lib$stop(%val(status))

	cmnd=0
c
c	Find out which flags are set
c

	cmnd=jiand(event_flags,'200'O)		! flag 7
	


	if(cmnd .ne. 0) then

c	<cntrl/a> key struck.   Get command from user

		status=sys$clref(%val(7))

c
c    set terminal to echo if not already
c
	if( .not. echo ) then
	   termchr(3) = iand ( termchr(3),.not. tnoecho)
	   status = sys$qiow(%val(11),%val(ttlun),io$_setmode,
	1,,,termchr(2),%val(0),,,,,)
	   if( .not. status) call lib$stop(%val(status))
	end if

c	zero command line

		command_line(1:)=char(0)
		type 200
200		format(/,1h$,' Command >')
		accept 210, command_line
210		format(a)

c
c    set terminal to noecho if it is supposed to be there
c
	if( .not. echo ) then
	   termchr(3) = ior ( termchr(3), tnoecho)
	   status = sys$qiow(%val(11),%val(ttlun),io$_setmode,
	1,,,termchr(2),%val(0),,,,,)
	   if( .not. status) call lib$stop(%val(status))
	end if
c
c	convert to upper case letters
c
		do i=1,80
		  if(ichar(command_line(i:i)) .ge. 97 .and.
	1            ichar(command_line(i:i)) .le. 122) then
		    command_line(i:i)=char(ichar(command_line(i:i))-32)
		  end if
		end do
c
c     See if it is a stop command
c
	Loc = index(command_line(1:4),sto(1:4))
	If(Loc .ne. 0) then
		type 112
112		format(//,' *** End of session ***',/)
		stop ' '
	end if

c
c	see if it is a send command
c

	loc=index(command_line(1:),send(1:4))
	if(loc .ne. 0) then
		local = .true.
		type 212
212		format(/)

c	get filename

		call getfil(command_line,filename,error,local)
		if( error ) goto 250

		p4b(1)='2B'X
		p4b(2)=0
		p4b(3)=0
		p4b(4)=0

c	open file and read from it

		open(unit=2,file=filename,status='old',readonly)
220		read(2,230,end=240)n,(buffer(ii),ii=1,n)
230		format(q,132a1)

c	send to modem

	status=sys$qiow(%val(2),%val(termlun),io$_writevblk,
	1,,,%ref(buffer),%val(n),,%val(p4),,)
	if(.not. status) call lib$stop(%val(status))

c	and write it to screen for him to see

	if(  echo ) then
		type 111,(buffer(jj),jj=1,n)
111		format(1h ,80a1)
	end if

		goto 220	! go get another one

240		close(unit=2)		!all done close out file
		type 241
241		format(//,' [ End of file ]',/)
		goto 250
	end if

c	see if it was a receive command

	loc=index(command_line(1:),recv(1:4))
	if(loc .ne. 0) then
		type 212

		if(rcv) close(unit=1) !file alread open close it

		local = .false.
		call getfil(command_line,filename,error,local)
		if( error ) goto 250

c	open up receive file

		open(unit=1,file=filename,status='new'
	1            ,carriagecontrol='list')
	
		rcv = .true.
		olen=0		!set output length to 0

		goto 250

	end if


c	see if it was a close command

	loc=index(command_line(1:),clo(1:4))
	if(loc .ne. 0) then
		type 212

		close(unit=1)	!close read file
	
		rcv = .false.
		olen=0
		type 245
245		format(//,' { Input file closed }',/)

		goto 250

	end if


		type *,' Unknown Command  '
		type 212

250		Call localast

		goto 100
	end if
	
c	error

	type *,'unknown event flag'

	end
c
c
c
c

	subroutine ttast(ttstat)
c
c	This is an AST routine to handle output to the modem
c	when the user enters a character
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4)
	byte ttbuf(80),termbuf(80)
	logical rcv
	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,olen

	external io$_writevblk,io$m_noformat,io$m_refresh

c	set up a write pass all

	func=%loc(io$_writevblk).or.%loc(io$m_noformat).or.
	1%loc(io$m_refresh)


c	see if he pressed a cntrl/a. If so go get command

	if(ttbuf(1) .eq. 1 ) then
		status=sys$setef(%val(7))
		if(.not. status) call lib$stop(%val(status))
		return
	end if


	p4=0

c	Ok , now write character to modem

	status=sys$qio(%val(3),%val(termlun),%val(func),
	1,,,%ref(ttbuf),%val(1),,%val(p4),,)
	if(.not. status) call lib$stop(%val(status))


10	ttbuf(1)=0
c   issue a new read request

	Call Localast
	

	return
	end
c
c
c
c

	subroutine termast(termstat)
c
c	This is an AST routine to handle output to the user terminal
c	when the modem sends a character
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),dskbuf(256)
	logical rcv
	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,olen

	external io$_ttyreadall,io$_writevblk,io$m_noformat,
	1io$m_refresh,ss$_timeout

	func=%loc(io$_writevblk).or.%loc(io$m_noformat).or.
	1%loc(io$m_refresh)

	p4=0
c	
c	write character from modem to user terminal
c


	status=sys$qio(%val(4),%val(ttlun),%val(func),
	1,,,%ref(termbuf),%val(1),,%val(p4),,)
	if(.not. status) call lib$stop(%val(status))

	if ( rcv ) then	! We are in receive mode

	if(termbuf(1) .ne. 13 ) Then	 !use <cr> as record delimitor
	    if(termbuf(1) .ne. 10) Then  !Don't write out linefeeds
		olen=olen+1
		dskbuf(olen)=termbuf(1)  ! add data to output buffer
	    End If
	Else

		write(1,6)(dskbuf(i),i=1,olen)
6		format(256a1)
		olen=0

	End If
	End If

	termbuf(1)=0

c   issue new read request

	Call Remoteast

	return
	end
c
c
c

	subroutine getfil(command,filename,error,local)
c
c	This routine is used to get a file name form command
c	and return it in filename after checking it for validity
c

	implicit integer (A-Z)
	character*(*) command
	character*(60) filename
	character*1 spc/' '/
	logical error,local,found
c
	error = .false.
	found = .false.
c
	do i=1,60
		filename(i:i)=char(0)
	end do

	loc = index(command(1:),spc(1:1))
	if(loc .eq. 0) then
		type 10
10		format(/,' Command line error')
		error = .true.
		return
	end if
c
	do i=loc,80	!find first character in filename
		indx = i
		if(ichar(command(i:i)) .gt. 32)go to 100
	end do
c
c	use default names
c
	if(local)filename='send.dat'
	if(.not. local)filename='recv.dat'
	goto 200
c
c
100	loc=0   ! load file name into filename
110	if(ichar(command(indx:indx)) .le. 32)goto 200
	loc = loc + 1
	filename(loc:loc) = command(indx:indx)
	indx = indx + 1
	goto 110
c
c	see if it is valid and check to see if it exists
c
200	inquire(file=filename,err=300,exist=found)
	goto 400

300		error = .true.
		type 350
350		format(/,' File specification error')
		return
c
c
400	if( local .and. found ) return  ! found one to send
	if( local .and. (.not. found))then
		type 450
450		format(/,' File not found') !didn't find one to send
		error = .true.
		return
	end if
c
	return
	end	
c
c
c

	Subroutine Remoteast
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),buffer(132),p4b(4)
	logical rcv,error,local

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,olen

	external io$_ttyreadall,io$m_refresh,termast,ttast
	external io$_writevblk,io$_readvblk
	equivalence (p4b(1),p4)

c
c	set up read function to pass all and refresh
c

	funcr=%loc(io$_ttyreadall)

c
c	Now issue an async read to the modem.
c	AST's will take care of the read.

	status=sys$qio(%val(2),%val(termlun),%val(funcr),
	1%ref(termstat),termast,termstat,%ref(termbuf),%val(1),,,,)
	if(.not. status) call lib$stop(%val(status))



	Return
	End
c
c
c

	Subroutine Localast
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),buffer(132),p4b(4)
	logical rcv,error,local

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,olen

	external io$_ttyreadall,io$m_refresh,termast,ttast
	external io$_writevblk,io$_readvblk
	equivalence (p4b(1),p4)

c
c	set up read function to pass all and refresh
c

	funcr=%loc(io$_ttyreadall)

c
c	Now issue an async read to his terminal 
c	AST's will take care of the read.
c
	status=sys$qio(%val(1),%val(ttlun),%val(funcr),
	1%ref(ttstat),ttast,ttstat,%ref(ttbuf),%val(1),,,,)
	if(.not. status) call lib$stop(%val(status))



	Return
	End
