
C  ratmig -- character handling and system-independent I/O for
C 		the RATFOR preprocessor and portable FORTRAN programs
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

C  scopy -- copy a character string to its full length
      integer function scopy ( in , out )
      byte in ( 1 ) , out ( 1 )
      continue
       i = 1
23000 if(.not.(in(i).ne.0))goto 23002
      out ( i ) = in ( i )
23001 i=i+1
      goto 23000
23002 continue
      out ( i ) = 0
C  terminate output string
      scopy = i - 1
      return
      end
C  of scopy

C  scopyl -- copy a character string given a maximum length
      integer function scopyl ( in , out , maxlen )
      byte in ( 1 ) , out ( 1 )
      integer maxlen
      continue
       i = 1
23003 if(.not.(i.le.maxlen.and.in(i).ne.0))goto 23005
      out ( i ) = in ( i )
23004 i=i+1
      goto 23003
23005 continue
      out ( i ) = 0
      scopyl = i - 1
      return
      end
C  of scopyl

C  makeuc -- translate alphabetics to upper case
      integer function makeuc ( str )
      byte str ( 1 ) , upper
      continue
       i = 1
23006 if(.not.(str(i).ne.0))goto 23008
      str ( i ) = upper ( str ( i ) )
23007 i=i+1
      goto 23006
23008 continue
      makeuc = i - 1
      return
      end
C  of makeuc

C  upper -- translate a character to upper case
      integer function upper ( c )
      byte c
      upper = c .and. " 177
      if(.not.( upper .lt. 97 ))goto 23009
      return
23009 continue
      if(.not.( upper .gt. 122 ))goto 23011
      return
23011 continue
      upper = upper .and. ( .not. " 40 )
      return
      end

C  makelc -- translate alphabetics to lower case
      integer function makelc ( str )
      byte str ( 1 ) , lower
      continue
       i = 1
23013 if(.not.(str(i).ne.0))goto 23015
      str ( i ) = lower ( str ( i ) )
23014 i=i+1
      goto 23013
23015 continue
      makelc = i - 1
      return
      end
C  of makelc

C  lower -- translate a character to lower case
      integer function lower ( c )
      byte c
      lower = c .and. " 177
      if(.not.( lower .lt. 65 ))goto 23016
      return
23016 continue
      if(.not.( lower .gt. 90 ))goto 23018
      return
23018 continue
      lower = lower .or. " 40
      return
      end

C  cvt -- remove blanks and control chars from string
      integer function cvt ( str )
      byte str ( 1 ) , chr
      integer in , out
      out = 1
      continue
       in = 1
23020 continue
      chr = str ( in )
      if(.not.( chr .eq. 0 ))goto 23023
      goto 23022
23023 continue
      if(.not.( chr .gt. 32 ))goto 23025
      str ( out ) = chr
      out = out + 1
23025 continue
23021 in=in+1
      goto 23020
23022 continue
      str ( out ) = 0
      cvt = out - 1
      return
      end
C  of cvt

C  trim -- remove trailing blanks and h.o. padding from string
      integer function trim ( buf )
C  returns length of string
      implicit integer ( a - z )
      byte buf ( 1 )
      continue
       i = 1
23027 continue
      buf ( i ) = buf ( i ) .and. " 177
C  remove h.o. bit(s)
      if(.not.( buf ( i ) .eq. 0 ))goto 23030
      goto 23029
23030 continue
23028 i=i+1
      goto 23027
23029 continue
      continue
       j = i - 1
23032 if(.not.(j.ge.1.and.buf(j).eq.32))goto 23034
C  locate last non-blank character
      continue
23033 j=j-1
      goto 23032
23034 continue
      buf ( j + 1 ) = 0
C  new terminator location
      trim = j
      return
      end

C  skipbl -- skip blanks and tabs and newline in a string
C 	(actually skips any control character as well)
      integer function skipbl ( str , pos )
      implicit integer ( a - z )
      byte str ( 1 )
      integer pos
      continue
       i = pos
23035 if(.not.(str(i).ne.0.and.str(i).le.32))goto 23037
      continue
23036 i=i+1
      goto 23035
23037 continue
      skipbl = i
C  return index to where we stopped
      return
      end

C  skipbl
C  findbl -- find first blank or tab in a string after a given position
C 		(actually stops at any control character as well)
      integer function findbl ( str , pos )
      implicit integer ( a - z )
      byte str ( 1 )
      integer pos
      continue
       i = pos
23038 if(.not.(str(i).gt.32.and.str(i).ne.0))goto 23040
      continue
23039 i=i+1
      goto 23038
23040 continue
      findbl = i
C  return index to where we stopped
      return
      end

C  findbl
C  findan -- skip non-alphanumeric characters in a string,
C 	    then stop at the next alphanumeric character (or EOS)
      integer function findan ( str , pos )
      implicit integer ( a - z )
      byte str ( 1 )
      integer pos , type , i , j , k
      continue
       i = pos
23041 if(.not.(str(i).ne.0))goto 23043
      k = type ( str ( i ) )
      if(.not.( k .eq. 1 .or. k .eq. 2 ))goto 23044
      goto 23043
23044 continue
23042 i=i+1
      goto 23041
23043 continue
      findan = i
C  return index to where we stopped
      return
      end

C  findan
C  skipan -- find first non-alpanumeric character after a given position
C 	    (skips alphanumeric characters -- also stops at EOS)
      integer function skipan ( str , pos )
      implicit integer ( a - z )
      byte str ( 1 )
      integer pos , type , i , j , k , lt
      lt = 1
      continue
       i = pos
23046 if(.not.(str(i).ne.0))goto 23048
      k = type ( str ( i ) )
C  treat periods preceeded by a digit as part of the a/n string
      if(.not.( k .eq. 46 .and. lt .eq. 2 ))goto 23049
      goto 23047
23049 continue
      lt = k
      if(.not.( k .ne. 1 .and. k .ne. 2 ))goto 23051
      goto 23048
23051 continue
23047 i=i+1
      goto 23046
23048 continue
      skipan = i
C  return index to where we stopped
      return
      end

C  skipan
C  lpad -- pad out a string to a given length by adding padding on the left
      integer function lpad ( str , padc , len )
C  returns length of result
      implicit integer ( a - z )
      byte str ( 1 ) , padc
      integer len
      integer dif
      lpad = length ( str )
      dif = len - lpad
      if(.not.( dif .gt. 0 ))goto 23053
      do 23055 i = lpad + 1 , 1 , - 1
C  "lpad+1" includes EOS
      str ( i + dif ) = str ( i )
23055 continue
23056 continue
C  move stuff over by difference
      do 23057 i = 1 , dif
      str ( i ) = padc
23057 continue
23058 continue
C  add left padding
      lpad = len
C  returns "len" unless original
C  string longer than "len"
23053 continue
      return
      end

C  rpad -- pad out a string to a given length by adding padding on the right
      integer function rpad ( str , padc , len )
C  returns length of result
      implicit integer ( a - z )
      byte str ( 1 ) , padc
      integer len
      rpad = length ( str )
      if(.not.( rpad .ge. len ))goto 23059
      return
C already long enough, just return length
23059 continue
      do 23061 j = rpad + 1 , len
      str ( j ) = padc
C else add padding character as required
23061 continue
23062 continue
      rpad = len
      str ( len + 1 ) = 0
C terminate
      return
      end

C  length -- length of an ASCIZ string
      integer function length ( str )
      byte str ( 1 )
      continue
       i = 1
23063 if(.not.(str(i).ne.0))goto 23065
23064 i=i+1
      goto 23063
23065 continue
      length = i - 1
      return
      end
C  of length

C  iscomp -- compare two character strings
      integer function iscomp ( str1 , str2 )
      byte str1 ( 1 ) , str2 ( 1 )
      continue
       i = 1
23066 continue
      iscomp = str1 ( i ) - str2 ( i )
      if(.not.( iscomp .ne. 0 ))goto 23069
      goto 23068
23069 continue
      if(.not.( str1 ( i ) .eq. 0 ))goto 23071
      goto 23068
23071 continue
23067 i=i+1
      goto 23066
23068 continue
      return
      end
C  of iscomp

C  indexx -- find position of pattern in string
      integer function indexx ( str , pattrn , start )
      byte str ( 1 ) , pattrn ( 1 )
      integer start
      integer lpat
      lpat = length ( pattrn )
      continue
       i = start
23073 if(.not.(str(i).ne.0))goto 23075
      if(.not.( str ( i ) .eq. pattrn ( 1 ) ))goto 23076
      continue
       j = 2
23078 if(.not.(j.le.lpat.and.str(i+j-1).eq.pattrn(j)))goto 23080
23079 j=j+1
      goto 23078
23080 continue
      if(.not.( j .gt. lpat ))goto 23081
      indexx = i
      return
23081 continue
23076 continue
23074 i=i+1
      goto 23073
23075 continue
      indexx = 0
C  failure to find
      return
      end
C  of indexx

C  rindex -- find position of pattern in string, searching from end to start
      integer function rindex ( str , pattrn , strt )
      byte str ( 1 ) , pattrn ( 1 )
      integer strt , start
      integer lpat
      lpat = length ( pattrn )
      start = length ( str )
      if(.not.( strt .gt. 0 .and. strt .lt. start ))goto 23083
      start = strt
C  use supplied start if in range, else use end
23083 continue
      start = start - lpat + 1
      continue
       i = start
23085 if(.not.(i.gt.0))goto 23087
      if(.not.( str ( i ) .eq. pattrn ( 1 ) ))goto 23088
      continue
       j = 2
23090 if(.not.(j.le.lpat.and.str(i+j-1).eq.pattrn(j)))goto 23092
23091 j=j+1
      goto 23090
23092 continue
      if(.not.( j .gt. lpat ))goto 23093
      rindex = i
      return
23093 continue
23088 continue
23086 i=i-1
      goto 23085
23087 continue
      rindex = 0
C  failure to find
      return
      end
C  of rindex

C  getstr -- get a line of input
      integer function getstr ( lun , line , lim )
      implicit integer ( a - z )
      integer lun , lim , length , scopy , scopyl , skipbl , findbl , st
     *emeq
      byte line ( 1 )
      logical first
C RT11	character rtline(81)
      c h a r a c t e r * 250 vmsline
      integer vmslen , vmserr
C TOPS	character runtk(4)
      data first / . true . /
C TOPS	data runtk /LETR, LETU, LETN, EOS/
C TOPS	length = lim	# "q" format not available
      if(.not.( lun .le. 0 ))goto 23095
      if(.not.( first ))goto 23097
      vmserr = lib $ get _ foreign ( vmsline , , vmslen )
      if(.not.( ( vmserr .and. 1 ) .eq. 0 ))goto 23099
      vmslen = 0
23099 continue
C error -- punt
      length = scopyl ( % ref ( vmsline ) , line , min0 ( lim , vmslen )
     * )
23097 continue
      if(.not.( .not. first .or. ( first .and. length .eq. 0 ) ))goto 23
     *101
      accept 100 , length , ( line ( i ) , i = 1 , min0 ( length , lim )
     * )
C TOPS	if (first)
C TOPS		call forrsc (length)
C TOPS	accept 100, (line(i), i=1, min0(length,lim))
C TOPS	if (first)
C TOPS	{	line(length+1) = EOS
C TOPS		j = findbl (line, 1)
C TOPS		line(j) = EOS
C TOPS		j = skipbl (line, min0(j+1,length))
C TOPS		# do not accept "r{un} xxx" lines (they have no data)
C TOPS		# or lines that have nothing after image name
C TOPS		if (stemeq(runtk,line) == NO & line(j) != EOS)
C TOPS			length = scopy (line(j), line)
C TOPS		else	# just do a normal read
C TOPS		{	length = lim
C TOPS			accept 100, (line(i), i=1, length)
C TOPS		}
C TOPS	}
C RSTS	accept 100, length, (line(i), i=1, min0(length,lim))
C RT11	call gtlin (rtline)
C RT11	length = scopyl (rtline, line, lim)
23101 continue
      first = . false .
C  for positive values of "lun":
      goto 23096
23095 continue
      read ( lun , 100 , err = 200 , end = 300 ) length , ( line ( i ) ,
     * i = 1 , min0 ( length , lim ) )
C TOPS	read (lun,100,err=200,end=300) (line(i), i=1, lim)
23096 continue
100   format ( q , 255 a1 )
C TOPS	100 format (255 CHARFORMAT)
      getstr = min0 ( length , lim )
      line ( getstr + 1 ) = 0
C TOPS	getstr = trim (line)
      return
200   getstr = - 4
      return
300   getstr = - 3
C  end of file
      return
      end
C  of getstr

C  putstr -- put a (possibly packed character) string
      logical function putstr ( lun , line , cc )
      implicit integer ( a - z )
      integer lun , icc
      byte line ( 1 ) , cc , ccc
      integer len
C TOPS	logical ispack
      putstr = . true .
C  assume success
      if(.not.( cc .eq. 0 ))goto 23103
      icc = 0
      goto 23104
23103 continue
      icc = 1
23104 continue
      if(.not.( lun .le. 0 .and. icc .eq. 0 ))goto 23105
      icc = 1
      ccc = 32
      goto 23106
23105 continue
      ccc = cc
C TOPS	if (! ispack (line))
C  the following code handles unpacked strings
23106 continue
      len = length ( line )
      if(.not.( lun .le. 0 ))goto 23107
      type 100 , ( ccc , i = 1 , icc ) , ( line ( i ) , i = 1 , len )
      goto 23108
23107 continue
      write ( lun , 100 , err = 9000 )  ( cc , i = 1 , icc ) , ( line ( 
     *i ) , i = 1 , len )
23108 continue
100   format ( a1 , 255 a1 )
C  the following code handles packed strings
C TOPS	else
C TOPS	{	# here we assume a system-dependent packing rate handled by "a" format
C  "cc" must still be right-adjusted ascii
C TOPS		len = lengp (line)
C TOPS		if (lun <= 0)
C TOPS			type 200, (ccc, i=1, icc), (line(i), i=1, len)
C TOPS		else
C TOPS			write (lun,200,err=9000)_
C TOPS				(cc, i=1, icc), (line(i), i=1, len)
C TOPS		200 format (CHARFORMAT, 255 a)
C TOPS	}
      putstr = . true .
      return
C  success
9000  putstr = . false .
C  error exit (probably out of space)
      return
      end
C  of putstr

C  ptprmt -- put a (possibly packed character) string, with no CR at end
      logical function ptprmt ( lun , line , cc )
      implicit integer ( a - z )
      integer lun , icc
      byte line ( 1 ) , cc , ccc
      integer len
C TOPS	logical ispack
      ptprmt = . true .
C  assume success
      if(.not.( cc .eq. 0 ))goto 23109
      icc = 0
      goto 23110
23109 continue
      icc = 1
23110 continue
      if(.not.( lun .le. 0 .and. icc .eq. 0 ))goto 23111
      icc = 1
      ccc = 32
      goto 23112
23111 continue
      ccc = cc
C TOPS	if (! ispack (line))
C  the following code handles unpacked strings
23112 continue
      len = length ( line )
      if(.not.( lun .le. 0 ))goto 23113
      type 100 , ( ccc , i = 1 , icc ) , ( line ( i ) , i = 1 , len )
      goto 23114
23113 continue
      write ( lun , 100 , err = 9000 )  ( cc , i = 1 , icc ) , ( line ( 
     *i ) , i = 1 , len )
23114 continue
100   format ( a1 , $ , 255 ( a1 , $ ) )
C  the following code handles packed strings
C TOPS	else
C TOPS	{	# here we assume a system-dependent packing rate handled by "a" format
C  "cc" must still be right-adjusted ascii
C TOPS		len = lengp (line)
C TOPS		if (lun <= 0)
C TOPS			type 200, (ccc, i=1, icc), (line(i), i=1, len)
C TOPS		else
C TOPS			write (lun,200,err=9000)_
C TOPS				(cc, i=1, icc), (line(i), i=1, len)
C TOPS		200 format (CHARFORMAT, $, 255 (a,$))
C TOPS	}
      ptprmt = . true .
      return
C  success
9000  ptprmt = . false .
C  error, probably out of space
      return
      end
C  of ptprmt

C  ispack -- decide if string is packed characters
      logical function ispack ( str )
      byte str ( 1 )
C  test for content greater than one right-adjusted char
C  such a string is assumed to be an unpacked EOS-terminated character array
      ispack = ( ( str ( 1 ) .and. ( .not. " 377 ) ) .ne. 0 )
C  this will always return "false" on byte systems
      return
      end
C  of ispack

C  lengp -- length of a packed string (returns element count, not character count)
      integer function lengp ( str )
      byte str ( 1 )
C  we hope to find a terminating l.o. zero
      continue
       i = 1
23115 if(.not.(i.le.100))goto 23117
      if(.not.( ( str ( i ) .and. " 377 ) .eq. 0 ))goto 23118
C  check the l.o. 8 bits
      goto 23117
C   (on the 36-bit systems, the 5
C    7-bit chars are LEFT adjusted)
23118 continue
23116 i=i+1
      goto 23115
23117 continue
      if(.not.( str ( i ) .eq. 0 ))goto 23120
      lengp = i - 1
      goto 23121
23120 continue
      lengp = i
C  this only works on systems where packed chars are packed from h.o. to l.o.
23121 continue
      return
      end
C  of lengp

C  ctoi - convert string at in(i) to integer, increment i
      integer function ctoi ( in , i )
      byte in ( 1 )
      integer indexx
      byte c ( 2 )
      integer d , i
C 	string digits "0123456789"
      byte digits ( 11 )
      data digits / 48 , 49 , 50 , 51 , 52 , 53 , 54 , 55 , 56 , 57 , 0 
     */
      data c ( 2 ) / 0 /
      continue
23122 if(.not.( in ( i ) .eq. 32 .or. in ( i ) .eq. 9 ))goto 23123
      i = i + 1
      goto 23122
23123 continue
      continue
       ctoi = 0
23124 if(.not.(in(i).ne.0))goto 23126
      c ( 1 ) = in ( i )
C  ensure zero-termination
      d = indexx ( digits , c , 1 )
      if(.not.( d .eq. 0 ))goto 23127
C  non-digit
      goto 23126
23127 continue
      ctoi = 10 * ctoi + d - 1
23125 i=i+1
      goto 23124
23126 continue
      return
      end

C  equal - compare str1 to str2; return YES if equal, NO if not
      integer function equal ( str1 , str2 )
      byte str1 ( 1 ) , str2 ( 1 )
      integer i
      continue
       i = 1
23129 if(.not.(str1(i).eq.str2(i)))goto 23131
      if(.not.( str1 ( i ) .eq. 0 ))goto 23132
      equal = 1
      return
23132 continue
23130 i=i+1
      goto 23129
23131 continue
      equal = 0
      return
      end

C  matchs - compare str1 to str2; return YES if equal, NO if not
      integer function matchs ( str1 , str2 )
      byte str1 ( 1 ) , str2 ( 1 )
      integer i , upper
      continue
       i = 1
23134 if(.not.(upper(str1(i)).eq.upper(str2(i))))goto 23136
      if(.not.( str1 ( i ) .eq. 0 ))goto 23137
      matchs = 1
      return
23137 continue
23135 i=i+1
      goto 23134
23136 continue
      matchs = 0
      continue
       j = i
23139 if(.not.(str1(j).ne.0))goto 23141
C scan for all-blank trailer
      if(.not.( str1 ( j ) .ne. 9 .and. str1 ( j ) .ne. 32 ))goto 23142
      return
23142 continue
23140 j=j+1
      goto 23139
23141 continue
      continue
       j = i
23144 if(.not.(str2(j).ne.0))goto 23146
C scan for all-blank trailer
      if(.not.( str2 ( j ) .ne. 9 .and. str2 ( j ) .ne. 32 ))goto 23147
      return
23147 continue
23145 j=j+1
      goto 23144
23146 continue
      matchs = 1
      return
      end

C  stemeq - compare master to another string;
C 	return YES if equal up to length of master, NO if not
C 	return NO if "tested" string is null
C 	compare without regard to case of alphabetics
      integer function stemeq ( master , tested )
      byte master ( 1 ) , tested ( 1 )
      integer i , upper
      continue
       i = 1
23149 if(.not.(upper(master(i)).eq.upper(tested(i))))goto 23151
      if(.not.( master ( i ) .eq. 0 ))goto 23152
      goto 23151
23152 continue
23150 i=i+1
      goto 23149
23151 continue
      if(.not.( i .gt. 1 .and. tested ( i ) .eq. 0 ))goto 23154
      stemeq = 1
      goto 23155
23154 continue
      stemeq = 0
23155 continue
      return
      end

C  itoc - convert integer  int  to char string in  str
      integer function itoc ( int , str , size )
      integer abs , mod
      integer d , i , int , intval , j , k , size
      byte str ( size )
C 	string digits "0123456789"
      byte digits ( 11 )
      data digits / 48 , 49 , 50 , 51 , 52 , 53 , 54 , 55 , 56 , 57 , 0 
     */
      intval = abs ( int )
      str ( 1 ) = 0
      i = 1
      continue
23156 continue
C  generate digits
      i = i + 1
      d = mod ( intval , 10 )
      str ( i ) = digits ( d + 1 )
      intval = intval / 10
23157 if(.not.( intval .eq. 0 .or. i .ge. size ))goto 23156
23158 continue
      if(.not.( int .lt. 0 .and. i .lt. size ))goto 23159
C  then sign
      i = i + 1
      str ( i ) = 45
23159 continue
      itoc = i - 1
      continue
       j = 1
23161 if(.not.(j.lt.i))goto 23163
C  then reverse
      k = str ( i )
      str ( i ) = str ( j )
      str ( j ) = k
      i = i - 1
23162 j=j+1
      goto 23161
23163 continue
      return
      end

C  ftocg -- convert a real number to a character string, using "g" format
      integer function ftocg ( r , str , max0 )
C returns length of "str"
      real r
      byte str ( 1 )
C must be at least "max+1"
      integer max0
      integer scopy , type
      byte pstr ( 21 )
C "packed" internal character string
      encode ( 20 , 100 , pstr ) r
100   format ( g )
C default g size
      call scopyl ( pstr , str , max0 )
      continue
       i = 1
23164 if(.not.(i.le.max0.and.str(i).ne.46))goto 23166
C  find decimal point
23165 i=i+1
      goto 23164
23166 continue
      continue
       i = i + 1
23167 if(.not.(i.le.max0.and.type(str(i)).eq.2))goto 23169
C  find first non-digit
23168 i=i+1
      goto 23167
23169 continue
      continue
       j = i - 1
23170 if(.not.(j.gt.0.and.str(j).eq.48))goto 23172
C  find least significant digit
23171 j=j-1
      goto 23170
23172 continue
      call scopy ( str ( i ) , str ( j + 1 ) )
C remove trailing zeros!
      continue
       i = 1
23173 if(.not.(i.le.max0.and.str(i).eq.32.and.str(i).ne.0))goto 23175
C  find first non-blank
23174 i=i+1
      goto 23173
23175 continue
      continue
       ftocg = scopy ( str ( i ) , str )
23176 if(.not.(str(ftocg).eq.32))goto 23178
      str ( ftocg ) = 0
C eliminate the blanks
C  the following is validation code that could be removed
23177 ftocg=ftocg-1
      goto 23176
23178 continue
      i = length ( str )
      if(.not.( i .ne. ftocg .or. i .gt. max0 ))goto 23179
      stop'RATLIB -- error in FTOCG'
23179 continue
      return
      end

C  strsub -- substitute an argument value for "%%" in a string
      integer function strsub ( instr , inouts , arg , type , maxl )
C  returns length of new string
      byte instr ( 1 ) , inouts ( 1 ) , type
C character/integer/real "arg" -- depending upon "type"
      dimension arg ( 1 )
C must dimension to keep TOPS-20 from making local copy
      integer maxl
      integer scopy , scopyl , length , indexx , itoc , ftocg , splice
      byte work ( 31 )
      integer pp , sl , l
      byte perper(3)
      byte errstr(8)
      data perper /'%','%',0/
      data errstr /'*','*','E','R','R','*','*',0/
C if "instr" is not a null string, first copy it to "inouts",
C -- else use "inouts" as-is
      if(.not.( instr ( 1 ) .ne. 0 ))goto 23181
      call scopyl ( instr , inouts , maxl )
23181 continue
      pp = indexx ( inouts , perper , 1 )
      if(.not.( pp .eq. 0 ))goto 23183
      l = length ( inouts )
      pp = l + 1
C if no "%%" found, put it at end
      goto 23184
23183 continue
      i = scopy ( inouts ( pp + 2 ) , inouts ( pp ) )
C remove the "%%"
      l = pp + i - 1
23184 continue
      if(.not.( type .eq. 0 .or. type .eq. 99 .or. type .eq. 115 ))goto 
     *23185

C "c"haracter "s"tring
      sl = length ( arg )
      if(.not.( sl + l .le. maxl ))goto 23187
C see if it fits
      strsub = splice ( inouts , arg , pp )
      goto 23188
23187 continue
C if it won't fit, copy what will fit up to "work" length
      call scopyl ( arg , work , min0 ( 30 , maxl - l ) )
      strsub = splice ( inouts , work , pp )
23188 continue
      goto 23186
23185 continue
      if(.not.( type .eq. 105 ))goto 23189
C "i"nteger
      call itoc ( arg , work , 30 )
      call scopyl ( work , work , maxl - l )
C truncate it if too big
      strsub = splice ( inouts , work , pp )
      goto 23190
23189 continue
      if(.not.( type .eq. 102 .or. type .eq. 114 ))goto 23191
C "f"loating point or "r"eal
      call ftocg ( arg , work , 30 )
      call scopyl ( work , work , maxl - l )
C truncate it if too big
      strsub = splice ( inouts , work , pp )
      goto 23192
23191 continue
C error, unrecognized type
      call scopyl ( errstr , work , maxl - l )
      strsub = splice ( inouts , work , pp )
C  the following is validation code that could be removed
23192 continue
23190 continue
23186 continue
      i = length ( inouts )
      if(.not.( i .ne. strsub .or. i .gt. maxl ))goto 23193
      stop'RATLIB -- error in STRSUB'
23193 continue
      return
      end

C  putdec - put decimal integer  n  in field width >= w
      subroutine putdec ( n , w , fd )
      byte chars ( 20 )
      integer itoc
      integer i , n , nd , w , fd
      nd = itoc ( n , chars , 20 )
      continue
       i = nd + 1
23195 if(.not.(i.le.w))goto 23197
      call putch ( 32 , fd )
23196 i=i+1
      goto 23195
23197 continue
      continue
       i = 1
23198 if(.not.(i.le.nd))goto 23200
      call putch ( chars ( i ) , fd )
23199 i=i+1
      goto 23198
23200 continue
      return
      end

C  splice - splice a string into the middle of another string
      integer function splice ( inout , in , pos )
      byte inout ( 1 ) , in ( 1 )
      integer pos
      byte c
      integer l1 , l2 , tpos , length
      l1 = length ( inout )
      l2 = length ( in )
      tpos = min0 ( l1 + 1 , max0 ( 1 , pos ) )
C  move tail end to make room
      continue
       i = l1 + l2 + 1
23201 if(.not.(i.ge.tpos+l2))goto 23203
      inout ( i ) = inout ( i - l2 )
23202 i=i-1
      goto 23201
23203 continue
      c = inout ( tpos + l2 )
C  save first, it will get clobbered
      call scopy ( in , inout ( tpos ) )
C  get insert
      inout ( tpos + l2 ) = c
C  restore it
      splice = l1 + l2
C  return length
      return
      end

C  strpqt -- strip quotes from a quoted string
      integer function strpqt ( str , qt )
      implicit integer ( a - z )
      byte str ( 1 ) , qt
      if(.not.( str ( 1 ) .ne. qt ))goto 23204
      strpqt = - 1
      return
23204 continue
      i = 2
      j = 1
      continue
23206 continue
      if(.not.( str ( i ) .eq. qt ))goto 23209
      i = i + 1
23209 continue
      str ( j ) = str ( i )
      if(.not.( str ( i ) .eq. 0 ))goto 23211
      goto 23208
23211 continue
      i = i + 1
      j = j + 1
23207 goto 23206
23208 continue
      strpqt = j - 1
      return
      end
C  of strpqt

C  puttyp -- add file type to end of file name if not specified
      integer function puttyp ( innam , outnam , type )
C return length of result
      byte innam ( 1 ) , outnam ( 1 ) , type ( 1 )
      logical indir , typfnd
      byte c
      integer scopy
      indir = . false .
      typfnd = . false .
      continue
       i = 1
23213 if(.not.(innam(i).ne.0))goto 23215
      c = innam ( i )
      outnam ( i ) = c
C  copy over while looking
      if(.not.( c .eq. 60 .or. c .eq. 91 ))goto 23216
      indir = . true .
      goto 23217
23216 continue
      if(.not.( c .eq. 62 .or. c .eq. 93 ))goto 23218
      indir = . false .
      goto 23219
23218 continue
      if(.not.( c .eq. 46 .and. .not. indir ))goto 23220
      typfnd = . true .
23220 continue
23219 continue
23217 continue
23214 i=i+1
      goto 23213
23215 continue
      outnam ( i ) = 0
      if(.not.( .not. typfnd .and. i .gt. 1 ))goto 23222
      outnam ( i ) = 46
      if(.not.( type ( 1 ) .eq. 46 ))goto 23224
      j = 2
      goto 23225
23224 continue
      j = 1
23225 continue
      l = scopy ( type ( j ) , outnam ( i + 1 ) ) + 1
C  add type to end if none found
      goto 23223
23222 continue
      l = 0
23223 continue
      puttyp = i - 1 + l
C return the length
      return
      end

C  prsdir -- parse a file spec to find end of "dev:[dir]" part
C  its is assumed that if present it precedes any other part of the file spec
      integer function prsdir ( fspec )
C return length of "dev:[dir]"
      byte fspec ( 1 )
      byte c
      prsdir = 0
C  first, assume no device or directory
      continue
       i = 1
23226 if(.not.(fspec(i).ne.0))goto 23228
      c = fspec ( i )
      if(.not.( c .eq. 62 .or. c .eq. 93 .or. c .eq. 58 ))goto 23229
      prsdir = i
23229 continue
23227 i=i+1
      goto 23226
23228 continue
      return
      end

C  openio -- open input and output files after obtaining names from user
      logical function openio ( in , out )
      implicit integer ( a - z )
      integer in , out
C  lun's
      byte buf ( 101 )
      logical openf
      openio = . false .
      type 100
100   format (' file>' , $ )
      if(.not.( getstr ( 0 , buf , 100 ) .le. 0 ))goto 23231
      return
C  error
23231 continue
      i = indexx ( buf ,'=' , 2 )
      if(.not.( i .ne. 0 ))goto 23233
      buf ( i ) = 0
23233 continue
      if(.not.( .not. openf ( in , buf ( i + 1 ) , 2 ) ))goto 23235
      goto 999
23235 continue
      if(.not.( .not. openf ( out , buf , 1 ) ))goto 23237
      goto 888
23237 continue
      openio = . true .
C  good return, both open
      return
999   type 200
200   format (' error in opening file:' )
      call putstr ( 0 , buf ( i + 1 ) , 32 )
      return
888   type 200
      call putstr ( 0 , buf , 32 )
      return
      end

C  type - return LETTER, DIGIT or character
C  this one works with ascii alphabet
      integer function type ( c )
      byte c
      if(.not.( c .ge. 48 .and. c .le. 57 ))goto 23239
      type = 2
      goto 23240
23239 continue
      if(.not.( c .ge. 97 .and. c .le. 122 ))goto 23241
      type = 1
      goto 23242
23241 continue
      if(.not.( c .ge. 65 .and. c .le. 90 ))goto 23243
      type = 1
      goto 23244
23243 continue
      type = c
23244 continue
23242 continue
23240 continue
      return
      end

C  setup -- issue GIGI terminal setup commands
      subroutine setup ( str )
      implicit integer ( a - z )
      byte str ( 1 ) , esc , bs
C TOPS	logical ispack
      data esc , bs / 155 , 92 /
C TOPS	if (! ispack (str))
      type 100 , esc , ( str ( i ) , i = 1 , length ( str ) ) , esc , bs
C TOPS	else
C TOPS	{	type 200, esc, (str(i), i=1, lengp(str))
C TOPS		type 300, esc, bs
C TOPS	}
100   format ('+' , a1 ,'Pr' , 255 ( a1 , $ ) )
C TOPS	200 format ('+', CHARFORMAT, 'Pr', 255 (a,$))
C TOPS	300 format ('+', 2 CHARFORMAT, $)
      return
      end

C  escseq -- send an escape sequence
      subroutine escseq ( str )
      implicit integer ( a - z )
      byte str ( 1 ) , esc
C TOPS	logical ispack
      data esc / 155 /
C TOPS	if (! ispack (str))
      type 100 , esc , ( str ( i ) , i = 1 , length ( str ) )
C TOPS	else
C TOPS		type 200, esc, (str(i), i=1, lengp(str))
100   format ('+' , 255 ( a1 , $ ) )
C TOPS	200 format ('+', 255 (a, $))
      return
      end

C  pack - convert an unpacked character string to most packed format
      integer function p a c k ( from , to )
      byte from ( 1 )
      byte to ( 32767 )
      l = length ( from )
C  "from" is in our right adjusted internal form
      encode ( l + 1 , 100 , to ) ( from ( i ) , i = 1 , l + 1 )
C  carry zero over
100   format ( 255 a1 )
      p a c k = l
      return
      end
C  of pack

C  unpack - convert a packed character string to internal format
      integer function u n p a c k ( from , to , l )
      implicit integer ( a - z )
      byte from ( 1 ) , to ( 1 )
      integer l
C  number of characters (or neg to let us determine it)
      integer length , lengp
      if(.not.( l .lt. 0 ))goto 23245
      len = lengp ( from ) * 1
      goto 23246
23245 continue
      len = l
23246 continue
      decode ( len , 100 , from ) ( to ( i ) , i = 1 , len )
100   format ( 255 a1 )
      to ( len + 1 ) = 0
C  "to" is in internal format
      u n p a c k = length ( to )
      return
      end
C  of unpack

C  dbgstr -- put a character string as both text and numbers onto the "type" device
      subroutine dbgstr ( str )
      byte str ( 1 )
      call putstr ( 0 , str , 32 )
      type 143 , ( str ( i ) , i = 1 , length ( str ) + 1 )
143   format (' ' , 10 i7 )
      return
      end

C  openf - open a file by name
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

      logical function openf ( lun , fname , modes )
      implicit integer ( a - z )
      integer lun , modes
      byte fname ( 1 )
d	integer errno, errlun
d	type *, 'openf - lun=', lun, '	modes=', modes
d	type 100, (fname(i), i=1, length(fname)), '|'
d 100	format (x, 100 a1)
d	call errsns (errno, errlun)
d	type 200, errno, errlun
d	call errsns		! clear any error info
      openf = . true .
      if(.not.( ( modes .and. 2 ) .ne. 0 ))goto 23000
      open ( unit = lun , name = fname , type ='OLD' , readonly , record
     *size = 256 , err = 5000 )
      goto 23001
23000 continue
      if(.not.( modes .eq. 0 ))goto 23002
C  old, list
      open ( unit = lun , name = fname , type ='OLD' , carriagecontrol =
     *'LIST' , recordsize = 256 , err = 5000 )
      goto 23003
23002 continue
      if(.not.( modes .eq. 4 ))goto 23004
C  old
      open ( unit = lun , name = fname , type ='OLD' , carriagecontrol =
     *'FORTRAN' , recordsize = 256 , err = 5000 )
C  OS dependent
      goto 23005
23004 continue
      if(.not.( modes .eq. 4 + 1 ))goto 23006
      open ( unit = lun , name = fname , type ='NEW' , carriagecontrol =
     *'FORTRAN' , recordsize = 256 , err = 5000 )
C  OS dependent
      goto 23007
23006 continue
      if(.not.( modes .eq. 1 ))goto 23008
      open ( unit = lun , name = fname , type ='NEW' , carriagecontrol =
     *'LIST' , recordsize = 256 , err = 5000 )
      goto 23009
23008 continue
      openf = . false .
C  illegal mode
23009 continue
23007 continue
23005 continue
23003 continue
23001 continue
      return
5000  openf = . false .
d	call errsns (errno, errlun)
d	type 200, errno, errlun
d 200	format (' fortran error number=', i, '	lun=', i)
      return
C  error return
      end

C  closef -- close a file by logical unit number
      logical function closef ( lun )
      integer lun
      close ( unit = lun , err = 9999 )
      closef = . true .
      return
9999  closef = . false .
      return
      end

C  vaxpack -- VMS-specific subroutines
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

C  sleep -- sleep a specified number of seconds, then continue
      subroutine sleep ( secs )
      integer secs
      integer * 4 dtime ( 2 )
      integer * 4 sys $ setimr , sys $ waitfr
      data dtime ( 2 ) / - 1 /
      dtime ( 1 ) = iabs ( secs ) * - 10 000 000
C  convert to .1 microsec units
      call sys $ setimr ( % val ( 10 ) , dtime , , )
      call sys $ waitfr ( % val ( 10 ) )
      return
      end
C  of sleep

C  lcinpt -- allow lower-case input
      subroutine lcinpt
C this is only needed on RSTS/E under RT-11 emulation (FORTRAN IV)
      return
      end
C  of lcinpt

C  rawtt - raw tt (special mode)
      subroutine rawtt
C this is only needed on RSTS/E under RT-11 emulation (FORTRAN IV)
      call ttnoek
      return
      end
C  of rawtt

C  normtt - normal tt handling (reverses the effect of "rawtt")
      subroutine normtt
C this is only needed on RSTS/E under RT-11 emulation (FORTRAN IV)
      call ttecho
      return
      end
C  of normtt

C  ttstat -- recover / set tt status (LSYSBUF bytes worth)
      subroutine ttstat ( mode , buf )
C this is only operative on RSTS/E
      call ttecho
      return
      end
C  of ttstat

C  ttnoek -- disable echoing to tt
      subroutine ttnoek
      common / ttcntrl / ttecsw
      logical ttecsw
C  "true" -> TTINxx calls routine that echoes
      ttecsw = . false .
      return
      end

C  ttsys -- setup sysbuf for sys call to set terminal characteristics
      subroutine ttsys
C this is only operative on RSTS/E
      return
      end

C  sysdmp -- dump sysbuf (for errors, etc.)
      subroutine sysdmp ( mess )
C this is only operative on RSTS/E
      stop'sysdmp - not implemented'
      end

C  ttecho -- enable echoing to tt
      subroutine ttecho
      common / ttcntrl / ttecsw
      logical ttecsw
C  "true" -> TTINxx calls routine that echoes
      ttecsw = . true .
      return
      end

C  ttwdth -- set tt wrap width
      subroutine ttwdth ( width )
      integer width
      if(.not.( width .lt. 250 ))goto 23000
      stop'ttwdth - width setting not implemented'
23000 continue
      return
      end

C  ttnoes -- disable special escape sequence processing
      subroutine ttnoes
      stop'enabling/disabling of special escape sequences is not impleme
     *nted'
      end

C  ttescq -- enable special escape sequence processing
      subroutine ttescq
      stop'enabling/disabling of special escape sequences is not impleme
     *nted'
      end

C  ttin -- read one character from terminal
      integer function ttin ( ecflag )
      implicit integer ( a - z )
      integer getln
      byte ecflag
C if zero, do not echo; otherwise, echo the char
      i = getln ( ttin , 1 , ecflag )
      if(.not.( i .eq. 0 ))goto 23002
      ttin = 0
C return 0 if nothing there?
23002 continue
      return
      end

C  prmtgt -- prompt at the terminal, then get a line of input
      integer function prmtgt ( outbuf , len , inbuf , maxlen )
      implicit integer ( a - z )
      byte outbuf ( 1 ) , inbuf ( 1 )
      integer len , maxlen
      integer getln
      call putln ( outbuf , len )
      prmtgt = getln ( inbuf , maxlen , 1 )
C  echo input
      return
      end

C  ttnorm -- reset TT parameters to normal values
      subroutine ttnorm
      call ttecho
      return
      end

C  ttinnw -- read one character from terminal with no wait if nothing there
      integer function ttinnw ( ecflag )
      implicit integer ( a - z )
      byte ecflag
C if zero, do not echo; otherwise, echo the char
      call getct ( ttinnw , 0 , ecflag )
C  time-out immediately
      ttinnw = ttinnw .and. " 177
C clear h.o. stuff
      return
      end
