
C  rbos -- remote basic operating system
C  make this "#" to omit debugging code
C  Host-side implementation of GIGI Basic SAVE, OLD, and HOST commands
C  When executed on a host attached to a GIGI terminal,
C  this program will set the terminal to local Basic (BA1) mode
C  and will continue to execute until the "HOST" command is issued to Basic.
C  This program will listen for requests and programs transmitted from GIGI.
C  It implements the following GIGI Basic commands:
C 	OLD "fname"
C 	SAVE "fname"
C 		where fname is any file descriptor valid on the host,
C 		enclosed in quotes as any GIGI Basic string.
C 		The file extension will default to "GGB" if not supplied.
C 		OLD retrieves a Basic program from the file on the host,
C 		after first clearing GIGI of any program or variables.
C 		SAVE copies the current Basic program into the named file.
C 		Both commands will issue a status message when done;
C 		the message will indicate either successful completion
C 		or an error.
C 		Then Basic will conclude the command by saying "OK".
C 	HOST
C 		This command terminates local GIGI Basic and switches the
C 		terminal to direct host communication.
C 		This program (RBOS) will terminate and return the
C 		user to the monitor level.
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

C  log file
C  terminal input buffer max length
C  character string defines
      byte ansitk(4)
      byte remtk(5)
      byte hosttk(5)
      byte oldtk(5)
      byte ggbtk(4)
      byte gudold(38)
      byte badold(41)
      byte savetk(6)
      byte weird(26)
      byte endtk(13)
      byte gudsav(17)
      byte badsav(34)
      byte eh(4)
      byte buf ( 100 ) , statbf ( 30 ) , esc
      integer get , l
      logical good , openf
      data ansitk /'T','M','1',0/
      data remtk /'R','E','M',' ',0/
      data hosttk /'H','O','S','T',0/
      data oldtk /'O','L','D',' ',0/
      data ggbtk /'G','G','B',0/
      data gudold /'Y','o','u','r',' ','w','i','s','h',' ','h','a','s','
     * ','b','e','e','n',' ','g','r','a','n','t','e','d',',',' ','O',' '
     *,'M','a','s','t','e','r','.',0/
      data badold /'Q','u','i','t','e',' ','f','r','a','n','k','l','y','
     *,',' ','I',' ','c','o','u','l','d','n','''','t',' ','f','i','n','d
     *',' ','t','h','e',' ','f','i','l','e','.',0/
      data savetk /'S','A','V','E',' ',0/
      data weird /'S','o','m','e','t','h','i','n','g',' ','w','e','i','r
     *','d',' ','h','a','p','p','e','n','e','d','.',0/
      data endtk /'R','E','M',' ','E','N','D',' ','S','A','V','E',0/
      data gudsav /'I','t','''','s',' ','b','e','e','n',' ','s','a','v',
     *'e','d','!',0/
      data badsav /'I',' ','c','a','n','''','t',' ','s','a','v','e',' ',
     *'a',' ','f','i','l','e',' ','b','y',' ','T','H','A','T',' ','n','a
     *','m','e','!',0/
      data eh /'E','h','?',0/
      data esc / 155 /
C RSTS	call lcinpt		# lower-case input
C TOPS	call openf (TERM, 'TTY:', NEWFILE+FORTRANCC)
      call openf ( 4 ,'TT:' , 1 + 4 )
      call openf ( 1 ,'RBOS.LOG' , 1 )
      call setup ( ansitk )
C  put GIGI in ANSI mode
      write ( 4 , 100 ) esc , esc
100   format ('+' , $ , a1 ,'[?21l' , a1 ,'[?21h' )
C  enable local basic
      continue
23000 continue
      l = get ( 4 , buf , 100 )
      if(.not.( l .lt. 0 ))goto 23003
      goto 23002
C  error or eof
23003 continue
      call putstr ( 1 , buf , 32 )
C  log all input
      i = indexx ( buf , remtk , 1 )
      if(.not.( i .gt. 0 .and. i .lt. 4 ))goto 23005
C  we should have one of the commands, look for it
      j = indexx ( buf , hosttk , i )
      if(.not.( j .gt. 0 ))goto 23007
C  HOST command
      call ttin ( 0 )
C  gobble the extra line feed
      stop'back to your friendly host'
23007 continue
      j = indexx ( buf , oldtk , i )
      if(.not.( j .gt. 0 ))goto 23009
C  OLD command
      call puttyp ( buf ( j + 4 ) , buf ( j + 4 ) , ggbtk )
      call putstr ( 1 , buf , 32 )
      if(.not.( .not. openf ( 2 , buf ( j + 4 ) , 2 ) ))goto 23011
      goto 777
23011 continue
      continue
23013 continue
C  til EOF
      if(.not.( get ( 2 , buf , 100 ) .lt. 0 ))goto 23016
      goto 23015
23016 continue
      call putln ( buf , length ( buf ) )
      call putln ( " 15 , 1 )
      call putstr ( 1 , buf , 32 )
23014 goto 23013
23015 continue
      call report ( gudold )
      close ( unit = 2 )
      if(.not.( . false . ))goto 23018
C  only executed if open error
777   call report ( badold )
23018 continue
      goto 23010
23009 continue
      j = indexx ( buf , savetk , i )
      if(.not.( j .gt. 0 ))goto 23020
C  SAVE command
      good = . true .
      call puttyp ( buf ( j + 5 ) , buf ( j + 5 ) , ggbtk )
      call putstr ( 1 , buf , 32 )
      good = openf ( 3 , buf ( j + 5 ) , 1 )
      continue
23022 continue
C  til REM END SAVE
      if(.not.( get ( 4 , buf , 100 ) .lt. 0 ))goto 23025
      call report ( weird )
      stop'input error during save'
23025 continue
      call putstr ( 1 , buf , 32 )
      if(.not.( indexx ( buf , endtk , 1 ) .gt. 0 ))goto 23027
      goto 23024
23027 continue
      if(.not.( good ))goto 23029
      call putstr ( 3 , buf , 0 )
23029 continue
23023 goto 23022
23024 continue
      if(.not.( good ))goto 23031
      close ( unit = 3 )
      call report ( gudsav )
      goto 23032
23031 continue
      call report ( badsav )
23032 continue
23020 continue
23010 continue
23005 continue
23001 goto 23000
23002 continue
      call report ( eh )
      stop'terminal input error'
      end
C  of rbos

C  get -- do a getln, then remove leading LF's and CR's
      integer function get ( lun , buf , max0 )
      implicit integer ( a - z )
      integer lun , max0 , getstr , getln
      byte buf ( 1 )
C DEBUG	type *, get, lun, max
C DEBUG	call dbgstr (buf)
      if(.not.( lun .eq. 4 .or. lun .eq. 0 ))goto 23033
      get = getln ( buf , max0 , 0 )
C  no echo from terminal
      goto 23034
23033 continue
      get = getstr ( lun , buf , max0 )
C DEBUG	type *, get, lun, max
C DEBUG	call dbgstr (buf)
23034 continue
      if(.not.( get .lt. 1 ))goto 23035
      return
C  error or EOF or null
23035 continue
      continue
23037 if(.not.( buf ( 1 ) .eq. " 12 .or. buf ( 1 ) .eq. " 15 ))goto 2303
     *8
      get = scopy ( buf ( 2 ) , buf )
      goto 23037
23038 continue
      continue
23039 if(.not.( buf ( get ) .eq. " 12 .or. buf ( get ) .eq. " 15 ))goto 
     *23040
      buf ( get ) = 0
      get = get - 1
C DEBUG	type *, get, lun, max
C DEBUG	call dbgstr (buf)
      goto 23039
23040 continue
      end
C  of get

C  report -- let a local basic user know what's happening after a file xfer
      subroutine report ( str )
      byte str ( 1 ) , dq , cr
      dq = 34
      cr = 13
      call putstr ( 1 , str , 32 )
      write ( 4 , 100 ) dq , ( str ( i ) , i = 1 , length ( str ) ) , dq
     * , cr
100   format ('+' ,'print #1, ' , 255 a1 )
      return
      end
